package com.nisum.employeeservice.service;

import com.nisum.employeeservice.model.Employee;
import com.nisum.employeeservice.repository.EmployeeRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class EmployeeService {

  @Autowired EmployeeRepository employeeRepository;


  public List<Employee> findAllEmployees() {
    /*some business*/
    return employeeRepository.findAll();
  }


  public Employee addEmployee(Employee employee) {
    return employeeRepository.save(employee);
  }

  public Employee updateEmployee(Long employeeId, Employee employeeDetails) {
    Optional<Employee> employee = employeeRepository.findById(employeeId);
    Employee updatedEmployee = employee.isPresent() ? employee.get() : new Employee();

    updatedEmployee.setFirstName(employeeDetails.getFirstName());
    updatedEmployee.setLastName(employeeDetails.getLastName());

    employeeRepository.save(updatedEmployee);
    return updatedEmployee;
  }

  public void deleteEmployee(Long employeeId) {
    employeeRepository.deleteById(employeeId);
  }
}
